/*
    AboutCmd.cc

    Will Eighteen, 2000 - 2005: will@opaline.demon.co.uk
*/


#include "AboutCmd.h"
#include "Application.h"
#include <TextEdit.h>


AboutCmd::AboutCmd ( const char *name, int active ) :  NoUndoCmd ( name, active )
{
	_popupRealised = FALSE;
}


AboutCmd::~AboutCmd()
{
	// 	empty
}


void AboutCmd::doCommand()
{
	if (_popupRealised == TRUE )
		return;

	_edit = new TextEdit ( ( char * ) name(), TRUE, &AboutCmd::okCallback, &AboutCmd::cancelCallback, ( void * ) this );	
	_edit->setRows ( 19 );
	_edit->setColumns ( 70 );
	_edit->setHelp ( "Please despatch help in liberal amounts to the \
author of this program!" );
	_popupRealised = TRUE;
	_edit->execute();
	_edit->setText ( "Mixwave\n\
Will Eighteen, 2000 - 2006: will@opaline.demon.co.uk\n\
This program is free software; you can redistribute it and/or modify \
it under the terms of the GNU General Public License as published by \
the Free Software Foundation; either version 2 of the License, or \
(at your option) any later version.\n\
This program is distributed in the hope that it will be useful, \
but WITHOUT ANY WARRANTY; without even the implied warranty of \
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU \
General Public License ('COPYING' in the Mixwave/doc source dir.) \
for more details.\n\
You should have received a copy of the GNU General Public License \
along with this program; if not, write to the Free Software \
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA." );

	_edit->setEditStatus ( False );
}


void AboutCmd::okCallback ( XtPointer clientData, char * text )
{
	AboutCmd *obj = ( AboutCmd * ) clientData;

	obj->ok( clientData );	// ok mapped to 'enter'
}


void AboutCmd::cancelCallback ( XtPointer clientData )
{
	AboutCmd *obj = ( AboutCmd * ) clientData;

	obj->ok( clientData );	// call ok to delete object
}


void AboutCmd::ok ( void *clientData )
{
	AboutCmd *obj = ( AboutCmd * ) clientData;

	if (obj->_popupRealised == TRUE )
	{
		obj->_popupRealised = FALSE;
		delete obj->_edit;
	}
}
